Attribute VB_Name = "modIMFMediaEngineNotify"
' Autor: F. Schler (frank@activevb.de)
' Datum: 09/2020

Option Explicit

' ----==== Types ====----
Private Type tIMFMediaEngineNotify
    pVTable As Long
End Type

Private Type tIMFMediaEngineNotifyVTable
    VTable(0 To 3) As Long
End Type

' ----==== Variablen ====----
Private m_NotifyEvent As MF_MEDIA_ENGINE_EVENT
Private m_NotifyParam1 As Long
Private m_NotifyParam2 As Long

Private m_RefCount As Long
Private m_pIMFMediaEngineNotify As Long
Private m_IMFMediaEngineNotify As tIMFMediaEngineNotify
Private m_IMFMediaEngineNotifyVTable As tIMFMediaEngineNotifyVTable

Public Function pIMFMediaEngineNotify() As Long

    ' ----==== Interface IMFMediaEngineNotify  ====----
    With m_IMFMediaEngineNotifyVTable
        
        ' VTable aufbauen
        .VTable(0) = ProcPtr(AddressOf QueryInterface)
        .VTable(1) = ProcPtr(AddressOf AddRef)
        .VTable(2) = ProcPtr(AddressOf Release)
        .VTable(3) = ProcPtr(AddressOf EventNotify)

    End With

    With m_IMFMediaEngineNotify

        ' Pointer auf die VTable
        .pVTable = VarPtr(m_IMFMediaEngineNotifyVTable)

    End With
    
    m_pIMFMediaEngineNotify = VarPtr(m_IMFMediaEngineNotify)
    
    ' Pointer auf das Interface
    pIMFMediaEngineNotify = m_pIMFMediaEngineNotify

End Function

Private Function ProcPtr(ByVal ptr As Long) As Long

    ProcPtr = ptr

End Function

' ----==== Interface IUnknown Func ====----
Private Function QueryInterface(ByVal this As Long, ByRef riid As GUID, ByRef _
    pvObj As Long) As Long

    Dim lRet As Long
    
    Select Case UCase$(Guid2Str(riid))

    ' wenn nach dem Interface IMFMediaEngineNotify gefragt wird
    Case UCase$(IID_IMFMediaEngineNotify)

        ' dann muss ein AddRef aufgerufen werden.
        Call AddRef(this)
        
        ' Pointer auf das Interface
        pvObj = m_pIMFMediaEngineNotify
        
        ' OK zurck geben, Interface ist vorhanden
        lRet = S_OK

    Case Else
        
        ' alles andere ignorieren
        
        pvObj = 0&
        
        lRet = E_NOINTERFACE
    
    End Select

    QueryInterface = lRet

End Function

Private Function AddRef(ByVal this As Long) As Long

    m_RefCount = m_RefCount + 1

    AddRef = m_RefCount

End Function

Private Function Release(ByVal this As Long) As Long

    m_RefCount = m_RefCount - 1
    
    Release = m_RefCount

End Function

' ----==== Interface IMFMediaEngineNotify Func ====----
Private Function EventNotify(ByVal this As Long, _
    ByVal lEvent As Long, ByVal Param1 As Long, _
    ByVal Param2 As Long) As Long
    
    ' Hier keinen Code einfgen der die Ausfhrung
    ' dieser Funktion blockiert!!! VBC wird dann
    ' abstrzen!!!
    
    ' Ich schummel hier ein wenig und setzte nur ein paar
    ' Variablen. Diese knnen dann per Timer abgefragt werden.
    m_NotifyEvent = lEvent
    m_NotifyParam1 = Param1
    m_NotifyParam2 = Param2
    
End Function

Public Function GetEvents(ByRef eNotifyEvent As MF_MEDIA_ENGINE_EVENT, _
    ByRef lNotifyParam1 As Long, ByRef lNotifyParam2 As Long) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    If m_NotifyEvent <> -1 Then

        eNotifyEvent = m_NotifyEvent
        lNotifyParam1 = m_NotifyParam1
        lNotifyParam2 = m_NotifyParam2
    
        bolRet = True
    
        m_NotifyEvent = -1
        m_NotifyParam1 = -1
        m_NotifyParam2 = -1
    
    End If

    GetEvents = bolRet
    
End Function
