Attribute VB_Name = "modMF"
' Autor: F. Schler (frank@activevb.de)
' Datum: 09/2020

Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Public Const VT_I4 As Long = &H3&
Public Const API_TRUE As Long = &H1&
Public Const API_FALSE As Long = &H0&
Public Const CC_STDCALL As Long = &H4&
Public Const IID_Release As Long = &H8&
Public Const D3DFMT_R8G8B8 As Long = &H14&
Public Const E_NOINTERFACE As Long = &H80004002
Public Const CLSCTX_INPROC_SERVER As Long = &H1&

Public Const MF_VERSION As Long = &H1&
Public Const MF_STARTUP_FULL As Long = &H0&

Public Const IID_IMFMediaEngineEx As String = "{83015ead-b1e6-40d0-a98a-37145ffe1ad1}"
Public Const IID_IMFMediaEngineNotify As String = "{fee7c112-e776-42b5-9bbf-0048524e2bd5}"
Public Const IID_IMFMediaEngineClassFactory As String = "{4d645ace-26aa-4688-9be1-df3516990b93}"

Public Const IID_IPropertyStore As String = "{886d8eeb-8cf2-4446-8d02-cdba1dbdcf99}"

Public Const CLSID_MFMediaEngineClassFactory As String = "{b44392da-499b-446b-a4cb-005fead0e6d5}"

Public Const MF_MEDIA_ENGINE_CALLBACK As String = "{c60381b8-83a4-41f8-a3d0-de05076849a9}"
Public Const MF_MEDIA_ENGINE_PLAYBACK_HWND As String = "{d988879b-67c9-4d92-baa7-6eadd446039d}"
Public Const MF_MEDIA_ENGINE_AUDIO_CATEGORY As String = "{c8d4c51d-350e-41f2-ba46-faebbb0857f6}"
Public Const MF_MEDIA_ENGINE_AUDIO_ENDPOINT_ROLE As String = "{d2cb93d1-116a-44f2-9385-f7d0fda2fb46}"
Public Const MF_MEDIA_ENGINE_VIDEO_OUTPUT_FORMAT As String = "{5066893c-8cf9-42bc-8b8a-472212e52726}"


' weitere Effekte: https://docs.microsoft.com/en-us/windows/win32/medfound/windowsmediadigitalsignalprocessors
'
' VideoEffekte
'
' VideoProcessorControl
Public Const CLSID_VideoProcessorMFT As String = "{88753b26-5b24-49bd-b2e7-0c445c78c982}"
Public Const IID_IMFVideoProcessorControl2 As String = "{bde633d3-e1dc-4a7f-a693-bbae399c4a20}"

'ColorControl
Public Const CLSID_CColorControlDMO As String = "{798059f0-89ca-4160-b325-aeb48efe4f9a}"
Public Const MFPKEY_COLOR_FMTID As String = "{174fb0ec-2695-476c-88aa-d2b41ce75e67}"

' ----==== Enums ====----
Public Enum vtb_Interfaces
    
    ' --== IUnknown ==--
    QueryInterface = 0
    
    ' --== IPropertyStore ==--
    GetValue = 5
    SetValue = 6
    
    ' --== IMFAttributes ==--
    SetUINT32 = 21
    SetUINT64 = 22
    SetUnknown = 27
    
    ' --== IMFMediaEngineClassFactory ==--
    CreateInstance = 3
    
    ' --== IMFMediaEngine ==--
'    GetError = 3
'    SetErrorCode = 4
'    SetSourceElements = 5
    SetSource = 6
'    GetCurrentSource = 7
'    GetNetworkState = 8
'    GetPreload = 9
'    SetPreload = 10
'    GetBuffered = 11
'    Load = 12
'    CanPlayType = 13
    GetReadyState = 14
'    IsSeeking = 15
    GetCurrentTime = 16
    SetCurrentTime = 17
'    GetStartTime = 18
    GetDuration = 19
'    IsPaused = 20
'    GetDefaultPlaybackRate = 21
'    SetDefaultPlaybackRate = 22
'    GetPlaybackRate = 23
'    SetPlaybackRate = 24
'    GetPlayed = 25
'    GetSeekable = 26
'    IsEnded = 27
'    GetAutoPlay = 28
'    SetAutoPlay = 29
'    GetLoop = 30
'    SetLoop = 31
    Play = 32
    Pause = 33
    GetMuted = 34
    SetMuted = 35
    GetVolume = 36
    SetVolume = 37
    HasVideo = 38
    HasAudio = 39
'    GetNativeVideoSize = 40
'    GetVideoAspectRatio = 41
    Shutdown = 42
'    TransferVideoFrame = 43
'    OnVideoStreamTick = 44
    
    ' --== IMFMediaEngineEx ==--
'    SetSourceFromByteStream = 45
'    GetStatistics = 46
'    UpdateVideoStream = 47
    GetBalance = 48
    SetBalance = 49
'    IsPlaybackRateSupported = 50
'    FrameStep = 51
'    GetResourceCharacteristics = 52
'    GetPresentationAttribute = 53
'    GetNumberOfStreams = 54
'    GetStreamAttribute = 55
'    GetStreamSelection = 56
'    SetStreamSelection = 57
'    ApplyStreamSelections = 58
'    IsProtected = 59
    InsertVideoEffect = 60
'    InsertAudioEffect = 61
    RemoveAllEffects = 62
'    SetTimelineMarkerTimer = 63
'    GetTimelineMarkerTimer = 64
'    CancelTimelineMarkerTimer = 65
'    IsStereo3D = 66
'    GetStereo3DFramePackingMode = 67
'    SetStereo3DFramePackingMode = 68
'    GetStereo3DRenderMode = 69
'    SetStereo3DRenderMode = 70
'    EnableWindowlessSwapchainMode = 71
'    GetVideoSwapchainHandle = 72
    EnableHorizontalMirrorMode = 73
'    GetAudioStreamCategory = 74
'    SetAudioStreamCategory = 75
'    GetAudioEndpointRole = 76
'    SetAudioEndpointRole = 77
'    GetRealTimeMode = 78
'    SetRealTimeMode = 79
    SetCurrentTimeEx = 80
'    EnableTimeUpdateTimer = 81
    
    ' --== IMFVideoProcessorControl ==--
'    SetBorderColor = 3
'    SetSourceRectangle = 4
'    SetDestinationRectangle = 5
'    SetMirror = 6
'    SetRotation = 7
'    SetConstrictionSize = 8
    
    ' --== IMFVideoProcessorControl2 ==--
'    SetRotationOverride = 9
    EnableHardwareEffects = 10
    GetSupportedHardwareEffects = 11

End Enum
   
Public Enum MFPKEY_COLOR_PID
    BRIGHTNESS = &H1&
    CONTRAST = &H2&
    HUE = &H3&
    SATURATION = &H4&
End Enum

Public Enum EngineMode
    AudioMode = &H0&
    RenderingMode = &H1&
    FrameServerMode = &H2&
End Enum

Public Enum ERole
    eConsole = &H0&
    eMultimedia = &H1&
    eCommunications = &H2&
End Enum

Public Enum AUDIO_STREAM_CATEGORY
    AudioCategory_Other = 0&
    AudioCategory_ForegroundOnlyMedia = 1&
    AudioCategory_BackgroundCapableMedia = 2&
    AudioCategory_Communications = 3&
    AudioCategory_Alerts = 4&
    AudioCategory_SoundEffects = 5&
    AudioCategory_GameEffects = 6&
    AudioCategory_GameMedia = 7&
    AudioCategory_GameChat = 8&
    AudioCategory_Speech = 9&
    AudioCategory_Movie = 10&
    AudioCategory_Media = 11&
End Enum

Public Enum MF_MEDIA_ENGINE_CREATEFLAGS
    MF_MEDIA_ENGINE_STANDARD = &H0&
    MF_MEDIA_ENGINE_AUDIOONLY = &H1&
    MF_MEDIA_ENGINE_WAITFORSTABLE_STATE = &H2&
    MF_MEDIA_ENGINE_FORCEMUTE = &H4&
    MF_MEDIA_ENGINE_REAL_TIME_MODE = &H8&
    MF_MEDIA_ENGINE_DISABLE_LOCAL_PLUGINS = &H10&
    MF_MEDIA_ENGINE_CREATEFLAGS_MASK = &H1F&
End Enum

Public Enum MF_MEDIA_ENGINE_READY
    MF_MEDIA_ENGINE_READY_HAVE_NOTHING = 0
    MF_MEDIA_ENGINE_READY_HAVE_METADATA = 1
    MF_MEDIA_ENGINE_READY_HAVE_CURRENT_DATA = 2
    MF_MEDIA_ENGINE_READY_HAVE_FUTURE_DATA = 3
    MF_MEDIA_ENGINE_READY_HAVE_ENOUGH_DATA = 4
End Enum

Public Enum MF_MEDIA_ENGINE_EVENT
    MF_MEDIA_ENGINE_EVENT_LOADSTART = 1&
    MF_MEDIA_ENGINE_EVENT_PROGRESS = 2&
    MF_MEDIA_ENGINE_EVENT_SUSPEND = 3&
    MF_MEDIA_ENGINE_EVENT_ABORT = 4&
    MF_MEDIA_ENGINE_EVENT_ERROR = 5&
    MF_MEDIA_ENGINE_EVENT_EMPTIED = 6&
    MF_MEDIA_ENGINE_EVENT_STALLED = 7&
    MF_MEDIA_ENGINE_EVENT_PLAY = 8&
    MF_MEDIA_ENGINE_EVENT_PAUSE = 9&
    MF_MEDIA_ENGINE_EVENT_LOADEDMETADATA = 10&
    MF_MEDIA_ENGINE_EVENT_LOADEDDATA = 11&
    MF_MEDIA_ENGINE_EVENT_WAITING = 12&
    MF_MEDIA_ENGINE_EVENT_PLAYING = 13&
    MF_MEDIA_ENGINE_EVENT_CANPLAY = 14&
    MF_MEDIA_ENGINE_EVENT_CANPLAYTHROUGH = 15&
    MF_MEDIA_ENGINE_EVENT_SEEKING = 16&
    MF_MEDIA_ENGINE_EVENT_SEEKED = 17&
    MF_MEDIA_ENGINE_EVENT_TIMEUPDATE = 18&
    MF_MEDIA_ENGINE_EVENT_ENDED = 19&
    MF_MEDIA_ENGINE_EVENT_RATECHANGE = 20&
    MF_MEDIA_ENGINE_EVENT_DURATIONCHANGE = 21&
    MF_MEDIA_ENGINE_EVENT_VOLUMECHANGE = 22&
    MF_MEDIA_ENGINE_EVENT_FORMATCHANGE = 1000&
    MF_MEDIA_ENGINE_EVENT_PURGEQUEUEDEVENTS = 1001&
    MF_MEDIA_ENGINE_EVENT_TIMELINE_MARKER = 1002&
    MF_MEDIA_ENGINE_EVENT_BALANCECHANGE = 1003&
    MF_MEDIA_ENGINE_EVENT_DOWNLOADCOMPLETE = 1004&
    MF_MEDIA_ENGINE_EVENT_BUFFERINGSTARTED = 1005&
    MF_MEDIA_ENGINE_EVENT_BUFFERINGENDED = 1006&
    MF_MEDIA_ENGINE_EVENT_FRAMESTEPCOMPLETED = 1007&
    MF_MEDIA_ENGINE_EVENT_NOTIFYSTABLESTATE = 1008&
    MF_MEDIA_ENGINE_EVENT_FIRSTFRAMEREADY = 1009&
    MF_MEDIA_ENGINE_EVENT_TRACKSCHANGE = 1010&
    MF_MEDIA_ENGINE_EVENT_OPMINFO = 1011&
    MF_MEDIA_ENGINE_EVENT_RESOURCELOST = 1012&
    MF_MEDIA_ENGINE_EVENT_DELAYLOADEVENT_CHANGED = 1013&
    MF_MEDIA_ENGINE_EVENT_STREAMRENDERINGERROR = 1014&
    MF_MEDIA_ENGINE_EVENT_SUPPORTEDRATES_CHANGED = 1015&
    MF_MEDIA_ENGINE_EVENT_AUDIOENDPOINTCHANGE = 1016&
End Enum

Public Enum MF_MEDIA_ENGINE_SEEK_MODE
    MF_MEDIA_ENGINE_SEEK_MODE_NORMAL = &H0&
    MF_MEDIA_ENGINE_SEEK_MODE_APPROXIMATE = &H1&
End Enum

Public Enum D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS
    D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_DENOISE = &H1&
    D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_DERINGING = &H2&
    D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_EDGE_ENHANCEMENT = &H4&
    D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_COLOR_CORRECTION = &H8&
    D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_FLESH_TONE_MAPPING = &H10&
    D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_IMAGE_STABILIZATION = &H20&
    D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_SUPER_RESOLUTION = &H40&
    D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_ANAMORPHIC_SCALING = &H80&
End Enum

' ----==== Type ====----
Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Public Type PROPERTYKEY
    fmtid As GUID
    pid As Long
End Type

Public Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    vPadding As Long
End Type

' ----==== Kernel32.dll Deklarationen ====----
Public Declare Sub CopyMemory Lib "kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef pTo As Any, _
                   ByRef uFrom As Any, _
                   ByVal lSize As Long)

Public Declare Function lstrlenW Lib "kernel32.dll" ( _
                        ByVal lpString As Long) As Long

' ----==== Oleaut32.dll Deklarationen ====----
Public Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                        ByVal pvInstance As Long, _
                        ByVal oVft As Long, _
                        ByVal cc As Long, _
                        ByVal vtReturn As VbVarType, _
                        ByVal cActuals As Long, _
                        ByVal prgvt As Any, _
                        ByVal prgpvarg As Any, _
                        ByRef pvargResult As Variant) As Long

' ----==== Ole32 API-Deklarationen ====----
Public Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
                   ByVal hMem As Long)

Public Declare Function CLSIDFromString Lib "ole32.dll" ( _
                        ByVal pstring As Long, _
                        ByRef pCLSID As GUID) As Long

Public Declare Function StringFromGUID Lib "ole32.dll" _
                        Alias "StringFromIID" ( _
                        ByRef pCLSID As GUID, _
                        ByRef lpszProgID As Long) As Long

Public Declare Function CoCreateInstance Lib "ole32.dll" ( _
                        ByVal rclsid As Long, _
                        ByVal pUnkOuter As Long, _
                        ByVal dwClsContext As Long, _
                        ByVal riid As Long, _
                        ByRef ppv As Long) As Long

Public Declare Function PropVariantClear Lib "ole32.dll" ( _
                        ByRef pVar As PROPVARIANT) As Long

' ----==== Mfplat.dll Deklarationen ====----
Public Declare Function MFStartup Lib "Mfplat.dll" ( _
                        ByVal Version As Long, _
                        ByVal dwFlags As Long) As Long

Public Declare Function MFShutdown Lib "Mfplat.dll" () As Long

Public Declare Function MFCreateAttributes Lib "Mfplat.dll" ( _
                        ByRef ppMFAttributes As Long, _
                        ByVal cInitialSize As Long) As Long

' ----==== Create Interface ====----
Public Function CreateInterface(ByVal sCLSID As String, _
    ByVal sIID As String, ByRef pInterface As Long) As Boolean

    Dim bRet As Boolean
    Dim tIID As GUID
    Dim tCLSID As GUID

    bRet = False
    
    ' CLSID -> GUID
    If CLSIDFromString(StrPtr(sCLSID), tCLSID) = S_OK Then

        ' IID -> GUID
        If CLSIDFromString(StrPtr(sIID), tIID) = S_OK Then

            ' Interface erstellen
            If CoCreateInstance(VarPtr(tCLSID), 0&, CLSCTX_INPROC_SERVER, _
                VarPtr(tIID), pInterface) = S_OK Then

                bRet = True

            End If

        End If

    End If

    CreateInterface = bRet

End Function

' ----==== Call OleInvoke ====----
Public Function Invoke(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces, _
    ByVal vReturn As VbVarType, ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, vReturn, var)
        
    End If
    
End Function

' ----==== Release Interface ====----
Public Sub Release(ByRef pInterface As Long)

    Dim vRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Private Function OleInvoke(ByVal pInterface As Long, ByVal lCmd As Long, _
    ByVal vReturn As VbVarType, ParamArray aParam()) As Variant
    
    Dim lCount As Long
    Dim lItem As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' wenn ein Pointer auf ein Interface vorhanden ist
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            vParam = aParam

            ' ist der Variant ein Array
            If IsArray(vParam) Then vParam = vParam(0)

            ' Anzahl der Parameter
            lCount = UBound(vParam)

            ' alle Parameter durchlaufen
            For lItem = 0 To lCount

                ' Typ des Parameter
                oleTyp(lItem) = VarType(vParam(lItem))

                ' Pointer auf den Parameter
                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If

        ' Funktion des Interfaces aufrufen
        If DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vReturn, _
            lItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), vRet) <> S_OK Then
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If

    End If
    
    OleInvoke = vRet

End Function

' ----==== String -> GUID ====----
Public Function Str2Guid(ByVal str As String) As GUID

    Call CLSIDFromString(StrPtr(str), Str2Guid)
    
End Function

' ----==== GUID -> String ====----
Public Function Guid2Str(ByRef tGUID As GUID) As String

    Dim lGuid As Long

    If StringFromGUID(tGUID, lGuid) = S_OK Then

        Guid2Str = Ptr2Str(lGuid)
    
    End If

End Function

' ----==== Pointer -> String ====----
Public Function Ptr2Str(ByVal lpStrPointer As Long) As String

    Dim lLen As Long
    Dim bBuffer() As Byte

    If lpStrPointer = 0 Then Exit Function

    lLen = lstrlenW(lpStrPointer) * 2& - 1&

    If lLen > 0& Then

        ReDim bBuffer(lLen)

        Call CopyMemory(bBuffer(0), ByVal lpStrPointer, lLen)
        
        Call CoTaskMemFree(lpStrPointer)

        Ptr2Str = bBuffer

    End If

End Function

' ----==== Seconds to Time ====----
Public Function Dbl2Time(ByVal dblSec As Double, Optional ByVal strFormat As _
    String = "hh:mm:ss") As String
    
    Dim lngHour As Long
    Dim lngMin As Long
    
    lngHour = dblSec \ 3600
    dblSec = dblSec Mod 3600
    lngMin = dblSec \ 60
    dblSec = dblSec Mod 60
    Dbl2Time = Format$(TimeSerial(lngHour, lngMin, dblSec), strFormat)
    
End Function

